unit AssignDevice;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TfrmAssignDevice = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    lbDeviceType: TListBox;
    lbPort: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormShow(Sender: TObject);
    procedure lbDeviceTypeClick(Sender: TObject);
    procedure lbPortClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    procedure SetButtons;
  public
    function SelectDevice(var APort : string; var ADevID : string) : integer;
  end;

var
  frmAssignDevice: TfrmAssignDevice;

implementation

{$R *.dfm}

uses
  SerialIO, Terminal;

// =============================================================================

procedure TfrmAssignDevice.FormShow(Sender: TObject);
var
  sl : TStringList;
  ii : integer;
begin
  sl := TStringList.Create;
  screen.Cursor := crHourGlass;
  try
    EnumerateComports(sl);
    lbPort.Items.Clear;
    lbPort.Items.Add('Not Assigned');
    for ii:=0 to sl.Count-1 do
      lbPort.Items.Add(sl.Names[ii]);
    Button1.Enabled := false;
  finally
    screen.Cursor := crDefault;
    sl.Free;
  end;
end;

// -----------------------------------------------------------------------------

function TfrmAssignDevice.SelectDevice(var APort : string; var ADevID : string) : integer;
begin
  result := 0;
  if ShowModal = mrOk then
  begin
    result := 1;
    case lbDeviceType.ItemIndex of
      0: ADevID := 'Stop Light V 5.4';
      1: ADevID := 'SLV1102a 20070219';
    end;
    APort := lbPort.Items[lbPort.ItemIndex];
  end;
end;

// -----------------------------------------------------------------------------

procedure TfrmAssignDevice.lbDeviceTypeClick(Sender: TObject);
begin
  SetButtons;
end;

// -----------------------------------------------------------------------------

procedure TfrmAssignDevice.lbPortClick(Sender: TObject);
begin
  SetButtons;
end;

// -----------------------------------------------------------------------------

procedure TfrmAssignDevice.SetButtons;
begin
  Button1.Enabled := ((lbDeviceType.ItemIndex >= 0) and (lbPort.ItemIndex >= 0));
  Button3.Enabled := (lbPort.ItemIndex > 0);
end;

// -----------------------------------------------------------------------------

procedure TfrmAssignDevice.Button3Click(Sender: TObject);
begin
  frmTerminal.OpenTerminal(lbPort.Items[lbPort.ItemIndex]);
end;

// -----------------------------------------------------------------------------

end.
