unit BrightnessEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, GenericCommand;

type
  TfrmBrightnessEditor = class(TForm)
    Button1: TButton;
    Button2: TButton;
    tb: TTrackBar;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure tbChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FCmd : TGenericCommand;
  public
    procedure OpenEditor(ACmd : TGenericCommand);
  end;

var
  frmBrightnessEditor: TfrmBrightnessEditor;

implementation

uses
  main, SerialIO;

{$R *.dfm}

// =============================================================================

procedure TfrmBrightnessEditor.OpenEditor(ACmd : TGenericCommand);
var
  row,col : integer;
  img : boolean;
  br : byte;
begin
  if not assigned(frmMain.Dev) then exit;
  FCmd := ACmd;
  br := UnhexByte(FCmd.Parameters['Level']);
  if br > 7 then br := 7;
  tb.Position := br;
  img := false;
  for row:=0 to frmMain.Dev.PCB.RowCount-1 do
    for col:=0 to frmMain.Dev.PCB.ColCount-1 do
    begin
      frmMain.Dev.PCB[col,row].Brightness := br;
      if frmMain.Dev.PCB[col,row].Active then img := true;
    end;
  if not img then
  begin
    for row:=0 to frmMain.Dev.PCB.RowCount-1 do
      for col:=0 to frmMain.Dev.PCB.ColCount-1 do
        frmMain.Dev.PCB[col,row].Active := true;
  end;
  frmMain.Invalidate;
  Show;
end;

// -----------------------------------------------------------------------------

procedure TfrmBrightnessEditor.FormShow(Sender: TObject);
begin
  DisableAPP;
end;

// -----------------------------------------------------------------------------

procedure TfrmBrightnessEditor.FormHide(Sender: TObject);
begin
  EnableAPP;
  frmMain.SavePositions(self);
end;

// -----------------------------------------------------------------------------

procedure TfrmBrightnessEditor.tbChange(Sender: TObject);
var
  row,col : integer;
  br : byte;
begin
  br := tb.Position;
  for row:=0 to frmMain.Dev.PCB.RowCount-1 do
    for col:=0 to frmMain.Dev.PCB.ColCount-1 do
      frmMain.Dev.PCB[col,row].Brightness := br;
  frmMain.Invalidate;
end;

// -----------------------------------------------------------------------------

procedure TfrmBrightnessEditor.Button2Click(Sender: TObject);
begin
  Close;
end;

// -----------------------------------------------------------------------------

procedure TfrmBrightnessEditor.Button1Click(Sender: TObject);
var
  br : byte;
begin
  br := tb.Position;
  FCmd.Parameters['Level'] := HexByte(br);
  Close;
end;

// -----------------------------------------------------------------------------

end.
