unit CallEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GenericCommand, StdCtrls;

type
  TfrmCallEditor = class(TForm)
    Button1: TButton;
    Button2: TButton;
    cbScript: TComboBox;
    lbCaption: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    FCmd : TGenericCommand;
    procedure LoadSLV11Scripts;
  public
    procedure OpenEditor(ACmd : TGenericCommand);
  end;

var
  frmCallEditor: TfrmCallEditor;

implementation

{$R *.dfm}

uses
  SLV11Commands, SerialIO, main;

// =============================================================================

procedure TfrmCallEditor.OpenEditor(ACmd : TGenericCommand);
var
  bb : byte;
begin
  FCmd := ACmd;
  cbScript.Clear;
  if FCmd is TSLV11Cmd_Call then
  begin
    LoadSLV11Scripts;
    lbCaption.Caption := 'Select Script to CALL:';
    Caption := 'Call Editor';
  end
  else
  if FCmd is TSLV11Cmd_GoTo then
  begin
    LoadSLV11Scripts;
    lbCaption.Caption := 'Select Script to EXECUTE:';
    Caption := 'GoTo Editor';
  end;
  bb := UnhexByte(FCmd.Parameters['Script']);
  if bb >= cbScript.Items.Count then bb := cbScript.Items.Count-1;
  cbScript.ItemIndex := bb;
  show;
end;

// -----------------------------------------------------------------------------

procedure TfrmCallEditor.LoadSLV11Scripts;
begin
  cbScript.Items.Add('Script 00000 (Parking Light - Accessory Power is Off)');
  cbScript.Items.Add('Script 00001 (Brake)');
  cbScript.Items.Add('Script 00010 (Left Turn)');
  cbScript.Items.Add('Script 00011 (Right Turn)');
  cbScript.Items.Add('Script 00100 (Emergency Signal)');
  cbScript.Items.Add('Script 00101 (Reverse)');
  cbScript.Items.Add('Script 00110 (Multipurpose Script)');
  cbScript.Items.Add('Script 00111 (Multipurpose Script)');
  cbScript.Items.Add('Script 01000 (Multipurpose Script)');
  cbScript.Items.Add('Script 01001 (Multipurpose Script)');
  cbScript.Items.Add('Script 01010 (Multipurpose Script)');
  cbScript.Items.Add('Script 01011 (Multipurpose Script)');
  cbScript.Items.Add('Script 01100 (Multipurpose Script)');
  cbScript.Items.Add('Script 01101 (Multipurpose Script)');
  cbScript.Items.Add('Script 01110 (Multipurpose Script)');
  cbScript.Items.Add('Script 01111 (Running Light - Accessory Power is On)');
  cbScript.Items.Add('Script 10000 (Multipurpose Script)');
  cbScript.Items.Add('Script 10001 (Multipurpose Script)');
  cbScript.Items.Add('Script 10010 (Multipurpose Script)');
  cbScript.Items.Add('Script 10011 (Multipurpose Script)');
  cbScript.Items.Add('Script 10100 (Multipurpose Script)');
  cbScript.Items.Add('Script 10101 (Multipurpose Script)');
  cbScript.Items.Add('Script 10110 (Multipurpose Script)');
  cbScript.Items.Add('Script 10111 (Multipurpose Script)');
  cbScript.Items.Add('Script 11000 (Multipurpose Script)');
  cbScript.Items.Add('Script 11001 (Multipurpose Script)');
  cbScript.Items.Add('Script 11010 (Multipurpose Script)');
  cbScript.Items.Add('Script 11011 (Multipurpose Script)');
  cbScript.Items.Add('Script 11100 (Multipurpose Script)');
  cbScript.Items.Add('Script 11101 (Multipurpose Script)');
  cbScript.Items.Add('Script 11110 (Multipurpose Script)');
  cbScript.Items.Add('Script 11111 (Multipurpose Script)');
end;

// -----------------------------------------------------------------------------

procedure TfrmCallEditor.Button2Click(Sender: TObject);
begin
  close;
end;

// -----------------------------------------------------------------------------

procedure TfrmCallEditor.Button1Click(Sender: TObject);
begin
  if cbScript.ItemIndex >= 0 then
    FCmd.Parameters['Script'] := HexByte(lo(cbScript.ItemIndex));
  close;
end;

// -----------------------------------------------------------------------------

procedure TfrmCallEditor.FormHide(Sender: TObject);
begin
  EnableAPP;
  frmMain.SavePositions(self);
end;

// -----------------------------------------------------------------------------

procedure TfrmCallEditor.FormShow(Sender: TObject);
begin
  DisableAPP;
end;

// -----------------------------------------------------------------------------

end.

