unit DelayEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, GenericCommand, ComCtrls;

type
  TfrmDelayEditor = class(TForm)
    Button1: TButton;
    Button2: TButton;
    edTime: TEdit;
    ud: TUpDown;
    rbTicks: TRadioButton;
    rbSeconds: TRadioButton;
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure udClick(Sender: TObject; Button: TUDBtnType);
    procedure rbTicksClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FCmd : TGenericCommand;
    FMx : double;
    procedure SetupEditBox;
  public
    procedure OpenEditor(ACmd : TGenericCommand; AMaxDelay : integer; AMx : double = 0.035);
  end;

var
  frmDelayEditor: TfrmDelayEditor;

implementation

{$R *.dfm}

uses
  Main, SerialIO;

// =============================================================================

procedure TfrmDelayEditor.OpenEditor(ACmd : TGenericCommand; AMaxDelay : integer; AMx : double);
var
  bb : byte;
begin
  if not assigned(frmMain.Dev) then exit;
  FCmd := ACmd;
  FMx := AMx;
  ud.Min := 1;
  ud.Max := AMaxDelay;
  bb := UnhexByte(FCmd.Parameters['Value']);
  if bb > AMaxDelay then bb := AMaxDelay;
  ud.Position := bb;
  SetupEditBox;
  frmMain.Invalidate;
  Show;
end;

// -----------------------------------------------------------------------------

procedure TfrmDelayEditor.SetupEditBox;
begin
  if rbTicks.Checked then
    edTime.Text := IntToStr(ud.Position)
  else
    edTime.Text := Format('%8.4f sec',[ud.Position*FMx]);
end;

// -----------------------------------------------------------------------------

procedure TfrmDelayEditor.Button2Click(Sender: TObject);
begin
  Close;
end;

// -----------------------------------------------------------------------------

procedure TfrmDelayEditor.FormShow(Sender: TObject);
begin
  DisableAPP;
end;

// -----------------------------------------------------------------------------

procedure TfrmDelayEditor.FormHide(Sender: TObject);
begin
  EnableAPP;
  frmMain.SavePositions(self);
end;

// -----------------------------------------------------------------------------

procedure TfrmDelayEditor.udClick(Sender: TObject; Button: TUDBtnType);
begin
  SetupEditBox;
end;

// -----------------------------------------------------------------------------

procedure TfrmDelayEditor.rbTicksClick(Sender: TObject);
begin
  SetupEditBox;
end;

// -----------------------------------------------------------------------------

procedure TfrmDelayEditor.Button1Click(Sender: TObject);
var
  bb : byte;
begin
  bb := ud.Position;
  FCmd.Parameters['Value'] := HexByte(bb);
  Close;
end;

// -----------------------------------------------------------------------------

end.
