unit MirrorEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, GenericCommand;

type
  TfrmMirrorEditor = class(TForm)
    Button1: TButton;
    Button2: TButton;
    rbNormal: TRadioButton;
    rbMirrored: TRadioButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    FCmd : TGenericCommand;
  public
    procedure OpenEditor(ACmd : TGenericCommand);
  end;

var
  frmMirrorEditor: TfrmMirrorEditor;

implementation

uses main;

{$R *.dfm}

// =============================================================================

procedure TfrmMirrorEditor.OpenEditor(ACmd : TGenericCommand);
begin
  FCmd := ACmd;
  if FCmd.Parameters['Value'] = 'MIRRORED' then
    rbMirrored.Checked := true
  else
    rbNormal.Checked := true;
  show;
end;

// -----------------------------------------------------------------------------

procedure TfrmMirrorEditor.Button2Click(Sender: TObject);
begin
  close;
end;

// -----------------------------------------------------------------------------

procedure TfrmMirrorEditor.Button1Click(Sender: TObject);
begin
  if rbNormal.Checked then
    FCmd.Parameters['Value'] := 'NORMAL'
  else
    FCmd.Parameters['Value'] := 'MIRRORED';
  close;
end;

// -----------------------------------------------------------------------------

procedure TfrmMirrorEditor.FormShow(Sender: TObject);
begin
  DisableAPP;
end;

// -----------------------------------------------------------------------------

procedure TfrmMirrorEditor.FormHide(Sender: TObject);
begin
  EnableAPP;
  frmMain.SavePositions(self);
end;

// -----------------------------------------------------------------------------

end.

