unit MsgEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, GenericCommand;

type
  TfrmMsgEditor = class(TForm)
    edMsg: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FCmd : TGenericCommand;
  public
    procedure OpenEditor(ACmd : TGenericCommand; AMaxLength : integer);
  end;

var
  frmMsgEditor: TfrmMsgEditor;

implementation

uses
  main, constants;

{$R *.dfm}

// =============================================================================

procedure TfrmMsgEditor.OpenEditor(ACmd : TGenericCommand; AMaxLength : integer);
var
  ss : string;
begin
  if not assigned(frmMain.Dev) then exit;
  FCmd := ACmd;
  edMsg.MaxLength := AMaxLength;
  ss := FCmd.Parameters['Msg'];
  if length(ss) > AMaxLength then ss := copy(ss,1,AMaxLength);
  edMsg.Text := ss;
  if AMaxLength = 0 then
    Label1.Caption := 'Enter a Message:'
  else
    Label1.Caption := 'Enter a Message (max. '+IntToStr(AMaxLength)+' characters):';

  frmMain.Invalidate;
  Show;
end;

// -----------------------------------------------------------------------------

procedure TfrmMsgEditor.FormShow(Sender: TObject);
begin
  DisableAPP;
  edMsg.SetFocus;
end;

// -----------------------------------------------------------------------------

procedure TfrmMsgEditor.FormHide(Sender: TObject);
begin
  EnableAPP;
  frmMain.SavePositions(self);
end;

// -----------------------------------------------------------------------------

procedure TfrmMsgEditor.Button2Click(Sender: TObject);
begin
  Close;
end;

// -----------------------------------------------------------------------------

procedure TfrmMsgEditor.Button1Click(Sender: TObject);
begin
  FCmd.Parameters['Msg'] := edMsg.Text;
  Close;
end;

// -----------------------------------------------------------------------------

end.
