unit ScriptSet;

interface

uses
  Classes, GenericCommand;

type
  TScriptSet = class (TList)
    procedure Clear; override;
  private
    function GetScript(Idx : byte) : TCommandSet;
    function GetSize : integer;
  public
    property Scripts[Idx : byte] : TCommandSet read GetScript; default;
    property Size : integer read GetSize;
  end;

implementation

// ========== TScriptSet =======================================================

procedure TScriptSet.Clear;
var
  ii : integer;
begin
  for ii:=0 to Count-1 do
    TCommandSet(items[ii]).Free;
  inherited Clear;
end;

// -----------------------------------------------------------------------------

function TScriptSet.GetScript(Idx : byte) : TCommandSet;
begin
  if (Idx >= Count) then
    result := nil
  else
    result := items[Idx];
end;

// -----------------------------------------------------------------------------

function TScriptSet.GetSize : integer;
var
  ii : integer;
begin
  result := 0;
  for ii:=0 to Count-1 do result := result+Scripts[ii].Size;
end;

// -----------------------------------------------------------------------------

end.
