unit SpcEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GenericCommand, StdCtrls, ComCtrls;

type
  TfrmSpcEditor = class(TForm)
    tb: TTrackBar;
    Button1: TButton;
    Button2: TButton;
    lbSpc: TLabel;
    Label1: TLabel;
    procedure tbChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    FCmd : TGenericCommand;
    FMaxValue : integer;
  public
    procedure OpenEditor(ACmd : TGenericCommand; AMaxValue : integer);
  end;

var
  frmSpcEditor: TfrmSpcEditor;

implementation

{$R *.dfm}

uses
  SerialIO, main;

// =============================================================================

procedure TfrmSpcEditor.OpenEditor(ACmd : TGenericCommand; AMaxValue : integer);
var
  b : byte;
begin
  FCmd := ACmd;
  FMaxValue := AMaxValue;
  tb.Min := 0;
  tb.Max := FMaxValue;
  b := UnhexByte(FCmd.Parameters['Value']);
  if b > FMaxValue then b := FMaxValue;
  tb.Position := b;
  lbSpc.Caption := IntToStr(b)+' col';
  show;
end;

// -----------------------------------------------------------------------------

procedure TfrmSpcEditor.tbChange(Sender: TObject);
begin
  lbSpc.Caption := IntToStr(tb.Position)+' col';
end;

// -----------------------------------------------------------------------------

procedure TfrmSpcEditor.Button2Click(Sender: TObject);
begin
  close;
end;

// -----------------------------------------------------------------------------

procedure TfrmSpcEditor.Button1Click(Sender: TObject);
begin
  FCmd.Parameters['Value'] := HexByte(lo(tb.Position));
  close;
end;

// -----------------------------------------------------------------------------

procedure TfrmSpcEditor.FormShow(Sender: TObject);
begin
  DisableAPP;
end;

// -----------------------------------------------------------------------------

procedure TfrmSpcEditor.FormHide(Sender: TObject);
begin
  EnableAPP;
  frmMain.SavePositions(self);
end;

// -----------------------------------------------------------------------------

end.

