unit selectdevice;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids;

type
  TfrmSelectDevice = class(TForm)
    dg: TDrawGrid;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure dgDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure Button3Click(Sender: TObject);
  private
    DevLst : TStringList;
  public
    function SelectDevice(ADevLst : TStringList) : integer;
  end;

var
  frmSelectDevice: TfrmSelectDevice;

function TS2DateStr(ts : string) : string;

implementation

uses Terminal;

{$R *.dfm}

// =============================================================================

function TS2DateStr(ts : string) : string;
var
  yy,mm,dd : integer;
begin
  yy := StrToIntDef(copy(ts,1,4),0);
  mm := StrToIntDef(copy(ts,5,2),0);
  dd := StrToIntDef(copy(ts,7,2),0);
  result := format('%2.2u/%2.2u/%4.4u',[mm,dd,yy]);
end;

// =============================================================================

function TfrmSelectDevice.SelectDevice(ADevLst : TStringList) : integer;
begin
  result := -1;
  DevLst := ADevLst;
  if DevLst.Count = 0 then
    dg.RowCount := 2
  else
    dg.RowCount := DevLst.Count+1;
  dg.FixedRows := 1;
  if ShowModal = mrOk then
    result := (dg.Selection.Top-1);
end;

// -----------------------------------------------------------------------------

procedure TfrmSelectDevice.Button3Click(Sender: TObject);
var
  row : integer;
begin
  row := dg.Selection.Top-1;
  if (row < 0) or (row >= DevLst.Count) then exit;
  frmTerminal.OpenTerminal(DevLst.Names[row]);
end;

procedure TfrmSelectDevice.dgDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  ss  : string;
  sid : string;
  ii  : integer;
begin
  ss := '';
  if ARow = 0 then
  begin
    case ACol of
      0: ss := 'Device ID';
      1: ss := 'Description';
      2: ss := 'Port';
      3: ss := 'Supported';
    end;
  end
  else
  begin
    dec(ARow);
    if (ARow < DevLst.Count) then
    begin
      ii := pos(' ',DevLst.ValueFromIndex[ARow]);
      if ii > 0 then
        sid := copy(DevLst.ValueFromIndex[ARow],1,ii-1)
      else
        sid := 'Unknown';
      case ACol of
        0:
        begin
          ss := DevLst.ValueFromIndex[ARow];
          if copy(ss,1,16) = 'Stop Light V 5.4' then
            ss := 'SLV0501'
          else
            ss := sid;
        end;
        1:
        begin
          ss := DevLst.ValueFromIndex[ARow];
          if copy(sid,1,5) = 'SLV05' then
            ss := 'Motorcycle Tail Light (V.'+copy(sid,6,255)+', '+TS2DateStr(copy(ss,length(ss)-7,8))+')'
          else
          if copy(sid,1,5) = 'SLV07' then
            ss := 'Bicycle Tail Light (V.'+copy(sid,6,255)+', '+TS2DateStr(copy(ss,length(ss)-7,8))+')'
          else
          if copy(sid,1,5) = 'SLV11' then
            ss := 'Car Tail Light Controller (V.'+copy(sid,6,255)+', '+TS2DateStr(copy(ss,length(ss)-7,8))+')'
          else
          if copy(ss,1,16) = 'Stop Light V 5.4' then
            ss := 'Motorcycle Tail Light (V.1)'
          else
            ss := 'Unknown Device ID';
        end;
        2: ss := DevLst.Names[ARow];
        3: ss := 'Y';
      end;
    end;
  end;
  dg.Canvas.TextRect(Rect,Rect.Left+2,Rect.Top+2,ss);
end;

// -----------------------------------------------------------------------------

end.
